-- 2021-04-22 License CC0 (Creative Commons license) (c) darkfrei

function love.load()
	local ddwidth, ddheight = love.window.getDesktopDimensions( display )
	if ddheight > 1080 then
		print('ddheight: ' .. ddheight)
		love.window.setMode(1920, 1080, {resizable=false, borderless=true})
	else
		love.window.setMode(ddwidth, ddheight-200, {resizable=true, borderless=false})
	end
	
	width, height = love.graphics.getDimensions( )
	canvas = love.graphics.newCanvas(width, height)
--	canvas:setFilter("nearest", "nearest")
	
	mpoints = {}
--	for i = 1, 3 do
--		local mpoint = {x = love.math.random(width), y=love.math.random(height)}
--		table.insert(mpoints, mpoint)
--	end
	mpoints[1] = {x = width/2, y=50}
	mpoints[2] = {x = 50, y=height-50}
	mpoints[3] = {x = width-50, y=height-50}
	
	npoints = 9
end

 
function love.update(dt)
--	for i = 1, 3 do
--		local mpoint = {x = love.math.random(width), y=love.math.random(height)}
--		table.insert(mpoints, mpoint)
--		mpoints[i] = mpoint
--	end
	
	love.graphics.setCanvas(canvas)
--		love.graphics.clear()
		local points = {}
		for k = 1, 10000 do
--			local i = love.math.random(#mpoints)
--			local i = love.math.random(3)
			local i = love.math.random(math.min(npoints, #mpoints))
--			if love.math.random() > 0.5 then
--				i = love.math.random(#mpoints)
--			end
--			local j = #mpoints
--			local j = love.math.random(#mpoints)
			local j = #mpoints
			
--			local mpoint = {x=0.5*mpoints[i].x + 0.5*mpoints[#mpoints].x,
--				y=0.5*mpoints[i].y + 0.5*mpoints[#mpoints].y}

--			local c = love.math.random()
--			local c = 0.33
			local c = 0.5
			local mpoint = {x=c*mpoints[i].x + (1-c)*mpoints[#mpoints].x,
				y=c*mpoints[i].y + (1-c)*mpoints[#mpoints].y}
			
--			table.insert(mpoints, mpoint)
			if npoints > (#mpoints-1) then
				table.insert(mpoints, mpoint)
			else
				mpoints[#mpoints] = mpoint
			end
			table.insert(points, mpoint.x)
			table.insert(points, mpoint.y)
		end
		love.graphics.points(points)
	love.graphics.setCanvas()
	
end


function love.draw()
	love.graphics.draw(canvas)
	love.graphics.print(npoints..' '..#mpoints)
end

function love.keypressed(key, scancode, isrepeat)
	if key == "escape" then
		love.event.quit()
	elseif key == "space" then
		mpoints={mpoints[1], mpoints[2], mpoints[3]}
		npoints = love.math.random (4, 16)
		
		love.graphics.setCanvas(canvas)
			love.graphics.clear()
		love.graphics.setCanvas()
	end
end